(function() {
    var Comparison, comparisons, o;
    Comparison = require('../qcons').Comparison;
    o = function(str, special_validation, decorate_value) {
        return new Comparison(str, special_validation, decorate_value);
    };
    comparisons = {
        exact: o('$1 = $2'),
        iexact: o('UPPER($1) = UPPER($2)'),
        lt: o('$1 < $2'),
        gt: o('$1 > $2'),
        lte: o('$1 <= $2'),
        gte: o('$1 >= $2'),
        "in": o('$1 in (@)'),
        isnull: o('$1 IS ? NULL'),
        contains: o('$1 LIKE $2', null, function(val) {
            return "%" + (val.replace(/%/g, '\\%')) + "%";
        }),
        startswith: o('$1 LIKE $2', null, function(val) {
            return "" + (val.replace(/%/g, '\\%')) + "%";
        }),
        endswith: o('$1 LIKE $2', null, function(val) {
            return "%" + (val.replace(/%/g, '\\%'));
        }),
        icontains: o('UPPER($1) LIKE UPPER($2)', null, function(val) {
            return "%" + (val.replace(/%/g, '\\%')) + "%";
        }),
        istartswith: o('UPPER($1) LIKE UPPER($2)', null, function(val) {
            return "" + (val.replace(/%/g, '\\%')) + "%";
        }),
        iendswith: o('UPPER($1) LIKE UPPER($2)', null, function(val) {
            return "%" + (val.replace(/%/g, '\\%'));
        }),
        range: o('$1 BETWEEN $2 AND $3'),
        year: o('EXTRACT(\'year\' from $1) = $2', function(val) {
            return !isNaN(val);
        }),
        month: o('EXTRACT(\'month\' from $1) = $2', function(val) {
            return !isNaN(val);
        }),
        day: o('EXTRACT(\'day\' from $1) = $2', function(val) {
            return !isNaN(val);
        }),
        week_day: o('EXTRACT(\'dow\' from $1) + 1 = $2', function(val) {
            return !isNaN(val);
        }),
        regex: o('$1 REGEXP $2')
    };
    exports.comparisons = comparisons;
    exports.o = o;
}).call(this);
