(function() {
    var BASE_FIELDS, DBField, SQLITE_BASE_FIELDS, SQLiteDBField, o, _ref;
    var __indexOf = Array.prototype.indexOf || function(item) {
      for (var i = 0, l = this.length; i < l; i++) {
        if (this[i] === item) return i;
      }
      return -1;
    };
    _ref = require('../fields'), DBField = _ref.DBField, BASE_FIELDS = _ref.BASE_FIELDS, o = _ref.o;
    SQLiteDBField = function() {
        DBField.apply(this, [].slice.call(arguments));
        return this;
    };
    SQLiteDBField.prototype = Object.create(DBField.prototype);
    SQLiteDBField.prototype.contribute_to_table = function(fields, pending_constraints, visited) {
        var _ref2;
        if (this.field.related && !(_ref2 = this.field.related, __indexOf.call(visited, _ref2) >= 0)) {
            this.defer_fk_constraint = function() {
                return true;
            };
        }
        return fields.push(this.framing().replace(/\n/g, ' '));
    };
    SQLITE_BASE_FIELDS = Object.create(BASE_FIELDS);
    SQLITE_BASE_FIELDS.date = o(null, 'DATE', {
        js_to_db: function(val) {
            var date;
            if (!isNaN(val)) {
                date = new Date([val.getUTCFullYear(), val.getUTCMonth() + 1, val.getUTCDate()].join('-') + ' 00:00:00 GMT');
                return ~~(date / 1000);
            } else {
                return val;
            }
        },
        db_to_js: function(val) {
            var date, tmpdate;
            if (val === null) {
                return val;
            } else {
                tmpdate = new Date(val * 1000);
                return date = new Date([tmpdate.getUTCFullYear(), tmpdate.getUTCMonth() + 1, tmpdate.getUTCDate()].join('-') + ' 00:00:00 GMT');
            }
        }
    });
    SQLITE_BASE_FIELDS.datetime = o(null, 'DATETIME', {
        js_to_db: function(val) {
            if (!isNaN(val)) {
                return ~~(val / 1000);
            } else {
                return val;
            }
        },
        db_to_js: function(val) {
            if (val === null) {
                return val;
            } else {
                return new Date(val * 1000);
            }
        }
    });
    exports.BASE_FIELDS = SQLITE_BASE_FIELDS;
    exports.DBField = SQLiteDBField;
}).call(this);
