(function() {
    var Creation, MigrationWriter;
    Creation = function(filename, using) {
        this.models = Array.isArray(models) ? models : [models];
        this.connection = using || 'default';
        return this;
    };
    Creation.prototype.initial = function() {
        var context, framing, _i, _len, _ref;
        framing = "CREATE TABLE {table_name} (\n    {fields}\n    {table_constraints}\n)";
        _ref = create_contexts(this.models);
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            context = _ref[_i];
            framing.replace(/\{[^\}]*\}/gm, function(all, repl) {
                return lookup(context, repl);
            });
        }
        return this;
    };
    Creation.prototype.alter_add_field = function(model, field_name) {
        return this;
    };
    Creation.prototype.alter_remove_field = function(model, field_name) {
        return this;
    };
    MigrationWriter = function(filename) {
        var key, model, val;
        this.models = (function() {
            var _ref, _results;
            _ref = require(filename);
            _results = [];
            for (key in _ref) {
                val = _ref[key];
                if (val instanceof BaseModel) {
                    _results.push(val);
                }
            }
            return _results;
        })();
        this.frozen = JSON.stringify((function() {
            var _i, _len, _ref, _results;
            _ref = this.models;
            _results = [];
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                model = _ref[_i];
                _results.push(this.freeze_model(model));
            }
            return _results;
        }).call(this));
        return this;
    };
    MigrationWriter.prototype.freeze_model = function(model) {
        var arg, arg_to_val, blob, field, out, _i, _len, _ref;
        blob = {};
        arg_to_val = function(arg) {
            if (arg instanceof BaseModel) {
                return arg.name;
            } else {
                return arg;
            }
        };
        _ref = model._schema.fields;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            field = _ref[_i];
            blob[field.name] = {
                type: field.type,
                args: (function() {
                    var _j, _len2, _ref2, _results;
                    _ref2 = field.original_arguments;
                    _results = [];
                    for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
                        arg = _ref2[_j];
                        _results.push(arg_to_val(arg));
                    }
                    return _results;
                })()
            };
        }
        out = {};
        out[model.name] = blob;
        return out;
    };
}).call(this);
