(function() {
    var AND, Comparison, DELETE, INSERT, NOT, OR, QCons, SELECT, SchemaError, UPDATE, ValidationError, _ref, _ref2;
    var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; }, __indexOf = Array.prototype.indexOf || function(item) {
      for (var i = 0, l = this.length; i < l; i++) {
        if (this[i] === item) return i;
      }
      return -1;
    };
    _ref = require('./constants'), AND = _ref.AND, OR = _ref.OR, NOT = _ref.NOT, SELECT = _ref.SELECT, INSERT = _ref.INSERT, UPDATE = _ref.UPDATE, DELETE = _ref.DELETE;
    _ref2 = require('./exceptions'), SchemaError = _ref2.SchemaError, ValidationError = _ref2.ValidationError;
    QCons = function(queryset) {
        this.queryset = queryset;
        this.mode = null;
        this.keys = [];
        this.tables = {};
        this.joins = [];
        this.join_sql = [];
        this.values = [];
        this.ordering = [];
        this.limit = null;
        this.where_clause = null;
        this.field_aliases = {};
        this.select_fields = null;
        this.register_table(this.queryset.model);
        return this;
    };
    QCons.prototype.set_fields = function(fields) {
        return this.select_fields = fields;
    };
    QCons.prototype.set_mode = function(mode) {
        return this.mode = mode;
    };
    QCons.prototype.set_limit = function(limit) {
        return this.limit = limit;
    };
    QCons.prototype.compile = function() {
        var field, fields, i, its_a_valid;
        if (this.mode === SELECT) {
            return ("SELECT " + (((function() {
                var _i, _len, _ref3, _results;
                _ref3 = this.select_fields;
                _results = [];
                for (_i = 0, _len = _ref3.length; _i < _len; _i++) {
                    field = _ref3[_i];
                    _results.push(this.get_db_repr(field));
                }
                return _results;
            }).call(this)).join(', ')) + " \nFROM " + (this.queryset.connection.quote(this.queryset.model._meta.db_table)) + " " + (this.get_table(this.queryset.model)) + "\n" + (this.join_sql.join(' ')) + "\n" + (this.where_clause ? 'WHERE ' + this.where_clause : '') + "\n" + (this.ordering.length ? 'ORDER BY ' + this.ordering.join(', ') : '') + "\n" + (this.limit ? 'LIMIT ' + this.limit.to + ' OFFSET ' + this.limit.from : '') + " ").replace(/\n/g, ' ');
        } else if (this.mode === INSERT) {
            its_a_valid = __bind(function(field) {
                if (field.primary_key) {
                    return this.payload[field.name] || this.payload['pk'];
                }
                return field.db_field && this.payload[field.name];
            }, this);
            fields = (function() {
                var _i, _len, _ref3, _results;
                _ref3 = this.keys;
                _results = [];
                for (_i = 0, _len = _ref3.length; _i < _len; _i++) {
                    field = _ref3[_i];
                    if (its_a_valid(field)) {
                        _results.push(this.queryset.connection.quote(field.db_field()));
                    }
                }
                return _results;
            }).call(this);
            return ("INSERT INTO " + this.queryset.model._meta.db_table + "\n" + (fields.length ? '(' + (fields.join(', ')) + ') VALUES' : '') + "\n" + (fields.length ? '(' + (((function() {
                var _ref3, _results;
                _results = [];
                for (i = 0, _ref3 = this.values.length; 0 <= _ref3 ? i < _ref3 : i > _ref3; 0 <= _ref3 ? i++ : i--) {
                    _results.push('$' + (i + 1));
                }
                return _results;
            }).call(this)).join(', ')) + ')' : '') + "\n" + (!fields.length ? 'DEFAULT VALUES' : '')).replace(/\n/g, ' ');
        } else if (this.mode === UPDATE) {
            return ("UPDATE " + this.queryset.model._meta.db_table + "\nSET\n" + (((function() {
                var _ref3, _results;
                _results = [];
                for (i = 0, _ref3 = this.keys.length; 0 <= _ref3 ? i < _ref3 : i > _ref3; 0 <= _ref3 ? i++ : i--) {
                    _results.push(this.keys[i].db_field() + ' = $' + (i + 1));
                }
                return _results;
            }).call(this)).join(', ')) + "\n" + (this.where_clause ? 'WHERE ' + this.where_clause : '') + "\n" + (this.join_sql.length ? ' AND (' + (this.join_sql.join(' AND ')) + ')' : '') + "\n" + (this.ordering.length ? 'ORDER BY ' + this.ordering.join(', ') : '') + "\n" + (this.limit ? 'LIMIT ' + this.limit.to + ' OFFSET ' + this.limit.from : '') + " ").replace(/\n/g, ' ');
        } else if (this.mode === DELETE) {
            return ("DELETE FROM " + this.queryset.model._meta.db_table + "\n" + (this.where_clause ? 'WHERE ' + this.where_clause : '') + "\n" + (this.join_sql.length ? ' AND (' + (this.join_sql.join(' AND ')) + ')' : '') + "\n" + (this.limit ? 'LIMIT ' + this.limit.to + ' OFFSET ' + this.limit.from : '') + " ").replace(/\n/g, ' ');
        }
    };
    QCons.prototype.prepared_values = function() {
        var db_field, field, i, out, _ref3;
        out = [];
        for (i = 0, _ref3 = this.keys.length; 0 <= _ref3 ? i < _ref3 : i > _ref3; 0 <= _ref3 ? i++ : i--) {
            field = this.keys[i];
            db_field = this.queryset.connection.negotiate_type(field);
            out.push(db_field.map.js_to_db(field.get_prepdb_value(this.values[i])));
        }
        return out.concat(this.values.slice(this.keys.length));
    };
    QCons.prototype.compile_where_clause = function(fields, cmp, value) {
        var field;
        if (this.mode === INSERT) {
            return;
        }
        field = this.get_field_and_register(fields);
        return cmp.compile(this.queryset.connection, field, value, __bind(function(value) {
            this.values.push(value);
            return this.values.length;
        }, this));
    };
    QCons.prototype.set_where = function(where_clause) {
        return this.where_clause = where_clause;
    };
    QCons.prototype.add_payload = function(payload) {
        var field, _i, _len, _ref3, _results;
        Object.keys(payload).forEach(__bind(function(field_name) {
            var field;
            field = this.get_field_and_register(field_name.split('__'));
            field = field.field;
            if (!field.validate_value(payload[field_name])) {
                throw new ValidationError("" + payload[field_name] + " is not a valid value for " + field.model._meta.name + "." + field.name);
            }
            this.keys.push(field);
            return this.values.push(payload[field_name]);
        }, this));
        this.payload = payload;
        if (this.mode === INSERT) {
            _ref3 = this.queryset.model._schema.fields;
            _results = [];
            for (_i = 0, _len = _ref3.length; _i < _len; _i++) {
                field = _ref3[_i];
                _results.push(__bind(function(field) {
                    var ret;
                    if (field.db_field() && __indexOf.call(this.keys, field) < 0) {
                        if (field.primary_key) {
                            return field;
                        } else if (field["default"]) {
                            if (field["default"] instanceof Function) {
                                ret = field["default"](__bind(function(val) {
                                    this.values.push(val);
                                    this.keys.push(field);
                                    return this.payload[field.name] = val;
                                }, this));
                                if (ret != null) {
                                    this.values.push(ret);
                                    this.keys.push(field);
                                    return this.payload[field.name] = ret;
                                }
                            } else {
                                this.values.push(field["default"]);
                                this.keys.push(field);
                                return this.payload[field.name] = field["default"];
                            }
                        } else if (!field.nullable) {
                            throw new ValidationError("" + field.name + " is required");
                        }
                    }
                }, this)(field));
            }
            return _results;
        }
    };
    QCons.prototype.add_ordering = function(field_name) {
        var dir, field;
        dir = 'ASC';
        if (field_name.charAt(0) === '-') {
            dir = 'DESC';
            field_name = field_name.slice(1);
        }
        field_name = field_name.split('__');
        field = this.get_field_and_register(field_name);
        return this.ordering.push("" + field.db_field + " " + dir);
    };
    QCons.prototype.register_table = function(model) {
        if (!this.tables[model._meta.db_table]) {
            this.tables[model._meta.db_table] = "T" + (Object.keys(this.tables).length);
        }
        return this.tables[model._meta.db_table];
    };
    QCons.prototype.register_join = function(by_field, seen_models) {
        var joins;
        if (this.joins.indexOf(by_field) === -1) {
            joins = by_field.join_struct();
            joins = joins.filter(function(join) {
                var _ref3;
                return !(_ref3 = join.rhs, __indexOf.call(seen_models, _ref3) >= 0);
            });
            if (joins.length === 0) {
                return;
            }
            this.joins.push(by_field);
            joins = joins.map(__bind(function(join) {
                var lhs_alias, rhs_alias, tbl, _ref3;
                lhs_alias = this.register_table(join.lhs);
                rhs_alias = this.register_table(join.rhs);
                tbl = __bind(function(model) {
                    return this.queryset.connection.quote(model._meta.db_table);
                }, this);
                if ((_ref3 = this.mode) === INSERT || _ref3 === DELETE || _ref3 === UPDATE) {
                    return "" + (tbl(join.lhs)) + "." + (this.queryset.connection.quote(join.lhs_field.db_field())) + " = " + (tbl(join.rhs)) + "." + (this.queryset.connection.quote(join.rhs_field.db_field()));
                } else if (this.mode === SELECT) {
                    return "" + join.join_type + " JOIN " + (tbl(join.rhs)) + " " + (this.queryset.connection.quote(rhs_alias)) + " ON (" + (this.get_db_repr(join.lhs_field)) + " = " + (this.get_db_repr(join.rhs_field)) + ")";
                }
            }, this));
            return this.join_sql = this.join_sql.concat(joins);
        }
    };
    QCons.prototype.get_table = function(model) {
        if (this.mode === UPDATE || this.mode === DELETE) {
            return this.queryset.connection.quote(model._meta.db_table);
        }
        return this.queryset.connection.quote(this.tables[model._meta.db_table]);
    };
    QCons.prototype.get_db_repr = function(field) {
        if (field.db_repr) {
            return field.db_repr(this.queryset.connection);
        } else {
            return "" + (this.get_table(field.model)) + "." + (this.queryset.connection.quote(field.db_field()));
        }
    };
    QCons.prototype.get_field_and_register = function(fields) {
        var last_field, model, seen_models;
        model = this.queryset.model;
        last_field = null;
        seen_models = [model];
        fields.forEach(__bind(function(field) {
            var new_model;
            this.register_table(model);
            if (last_field) {
                new_model = last_field.related;
                this.register_join(last_field, seen_models);
                seen_models.push(new_model);
                model = new_model;
                last_field = model._schema.get_field_by_name(field);
            } else {
                last_field = model._schema.get_field_by_name(field);
            }
            if (!last_field) {
                throw new SchemaError("" + (fields.join('__')) + " is not a valid field!");
            }
        }, this));
        return {
            db_field: "" + (this.get_table(model)) + "." + (this.queryset.connection.quote(last_field.db_field())),
            field: last_field
        };
    };
    QCons.prototype.coerce = function(rows) {
        var BaseModel, connection, db_to_js, field, fields, model, num_real_fields, process;
        BaseModel = require('./models').BaseModel;
        connection = this.queryset.connection;
        fields = this.select_fields;
        num_real_fields = fields.length - ((function() {
            var _i, _len, _results;
            _results = [];
            for (_i = 0, _len = fields.length; _i < _len; _i++) {
                field = fields[_i];
                if (field.is_decoration) {
                    _results.push(field);
                }
            }
            return _results;
        })()).length;
        if (Array.isArray(rows)) {
            model = this.queryset.model;
            db_to_js = function(fn) {
                return function(row) {
                    var db_field, decoration, field, key, out, val, _i, _len;
                    out = {};
                    decoration = {};
                    if (fields) {
                        for (_i = 0, _len = fields.length; _i < _len; _i++) {
                            field = fields[_i];
                            db_field = connection.negotiate_type(field);
                            key = field.db_field();
                            val = db_field.map.db_to_js(row[key]);
                            if (field.is_decoration) {
                                decoration[key] = val;
                            } else {
                                out[key] = val;
                            }
                        }
                    }
                    return fn(out, decoration);
                };
            };
            if (this.mode === INSERT) {
                process = __bind(function(row) {
                    var idx, instance, value, _ref3, _ref4;
                    instance = new model(row);
                    for (idx = 0, _ref3 = this.keys.length; 0 <= _ref3 ? idx < _ref3 : idx > _ref3; 0 <= _ref3 ? idx++ : idx--) {
                        _ref4 = [this.keys[idx], this.values[idx]], field = _ref4[0], value = _ref4[1];
                        if (value instanceof BaseModel) {
                            instance._fk_cache[field.name] = instance._fk_cache[field.name] || {};
                            instance._fk_cache[field.name].instance = value;
                        }
                    }
                    return instance;
                }, this);
            } else {
                process = function(row, decoration) {
                    var instance, key, val, _len;
                    if (num_real_fields) {
                        instance = new model(row);
                        for (val = 0, _len = decoration.length; val < _len; val++) {
                            key = decoration[val];
                            instance[key] = val;
                        }
                        return instance;
                    } else {
                        return decoration;
                    }
                };
            }
            rows = rows.map(db_to_js(process));
            rows.sql = __bind(function() {
                return this.compile();
            }, this);
            rows.values = __bind(function() {
                return this.values;
            }, this);
            if (this.mode === INSERT) {
                return rows[0];
            }
        }
        return rows;
    };
    Comparison = function(string, special_validation, decorate_value) {
        this.string = string;
        this.special_validation = special_validation || null;
        this.decorate_value = decorate_value || null;
        return this;
    };
    Comparison.prototype.compile = function(connection, qcons_field, value, register_value) {
        var db_field, decorate, lower, map, special_validation, str, upper, validation, values;
        validation = qcons_field.field.validate_comparison.bind(qcons_field.field);
        db_field = connection.negotiate_type(qcons_field.field);
        special_validation = false;
        if (this.special_validation) {
            special_validation = true;
            validation = this.special_validation;
        }
        decorate = function(val) {
            return val;
        };
        map = special_validation ? function(v) {
            return v;
        } : db_field.map.js_to_db;
        if (this.decorate_value) {
            decorate = this.decorate_value;
        }
        if (this.string.indexOf('@') !== -1) {
            values = value.map(function(val) {
                if (!validation(val)) {
                    throw new ValidationError("" + val + " is not a valid value for " + qcons_field.field.model._meta.name + "." + qcons_field.field.name);
                }
                return register_value(decorate(map(qcons_field.field.get_prepdb_value(val))));
            });
            str = this.string.replace('@', '$' + values.join(',$'));
        } else if (this.string.indexOf('?') !== -1) {
            value = !!value;
            str = this.string.replace('?', ['NOT', ''][~~value]);
        } else if (this.string.indexOf('BETWEEN') !== -1) {
            lower = value[0], upper = value[1];
            lower = decorate(map(qcons_field.field.get_prepdb_value(lower)));
            upper = decorate(map(qcons_field.field.get_prepdb_value(upper)));
            lower = register_value(lower);
            upper = register_value(upper);
            str = this.string.replace('$3', '$' + upper);
            str = str.replace('$2', '$' + lower);
        } else {
            if (!validation(value)) {
                throw new ValidationError("" + value + " is not a valid value for " + qcons_field.field.model._meta.name + "." + qcons_field.field.name);
            }
            value = register_value(decorate(map(qcons_field.field.get_prepdb_value(value))));
            str = this.string.replace('$2', '$' + value);
        }
        return str.replace('$1', qcons_field.db_field);
    };
    exports.Comparison = Comparison;
    exports.QCons = QCons;
}).call(this);
