(function() {
  var Model, models, ns;
  models = require('../../').models;
  Model = require('./models').Model;
  ns = models.namespace('related', function(ns) {
    var Many, Related;
    Related = ns.create('Related');
    Related.schema({
      model: models.ForeignKey(Model),
      pub_date: models.DateField({
        nullable: true
      })
    });
    Related.prototype.toString = function() {
      return "<Related: " + this.pk + ">";
    };
    Many = ns.create('ManyToMany');
    Many.schema({
      related: models.ManyToMany(Related),
      fulltime: models.DateTimeField({
        nullable: true
      })
    });
    Many.prototype.toString = function() {
      return "<Many: " + this.pk + ">";
    };
    exports.Related = Related;
    return exports.Many = Many;
  });
  exports.ns = ns;
}).call(this);
